diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 62dd4fe6346..853066fadd1 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -7615,6 +7993,7 @@ merge_fdw_options(PgFdwRelationInfo *fpinfo,
 	fpinfo->use_remote_estimate = fpinfo_o->use_remote_estimate;
 	fpinfo->fetch_size = fpinfo_o->fetch_size;
 	fpinfo->async_capable = fpinfo_o->async_capable;
+	fpinfo->streaming_fetch = fpinfo_o->streaming_fetch;
 
 	/* Merge the table level options from either side of the join. */
 	if (fpinfo_i)
@@ -7646,6 +8025,11 @@ merge_fdw_options(PgFdwRelationInfo *fpinfo,
 		 */
 		fpinfo->async_capable = fpinfo_o->async_capable ||
 			fpinfo_i->async_capable;
+		fpinfo->streaming_fetch = fpinfo_o->streaming_fetch ||
+			fpinfo_i->streaming_fetch;
+		/* streaming_fetch and async execution are mutually exclusive */
+		if (fpinfo->streaming_fetch)
+			fpinfo->async_capable = false;
 	}
 }
 
@@ -8800,6 +9184,12 @@ fetch_more_data_begin(AsyncRequest *areq)
 	if (!fsstate->scan_in_progress)
 		create_cursor(node);
 
+	/*
+	 * If the other scan is using streaming_fetch mode, then save the tuples
+	 * to tuplestore before sending a new query down this connection.
+	 */
+	drain_other_active_scan(fsstate->conn_state);
+
 	/* We will send this query, but not wait for the response. */
 	snprintf(sql, sizeof(sql), "FETCH %d FROM c%u",
 			 fsstate->fetch_size, fsstate->cursor_number);
diff --git a/contrib/postgres_fdw/postgres_fdw.h b/contrib/postgres_fdw/postgres_fdw.h
index da7da1c2ea9..092ea580e21 100644
--- a/contrib/postgres_fdw/postgres_fdw.h
+++ b/contrib/postgres_fdw/postgres_fdw.h
@@ -88,6 +88,7 @@ typedef struct PgFdwRelationInfo
 	UserMapping *user;			/* only set in use_remote_estimate mode */
 
 	int			fetch_size;		/* fetch size for this remote table */
+	bool		streaming_fetch;	/* true if cursor-free fetch is enabled */
 
 	/*
 	 * Name of the relation, for use while EXPLAINing ForeignScan.  It is used
@@ -141,12 +142,16 @@ typedef struct PgFdwRelationInfo
 	int			relation_index;
 } PgFdwRelationInfo;
 
+typedef struct PgFdwScanState PgFdwScanState;
+
 /*
  * Extra control information relating to a connection.
  */
 typedef struct PgFdwConnState
 {
 	AsyncRequest *pendingAreq;	/* pending async request */
+	PgFdwScanState *active_scan;	/* the streaming_fetch scan, if any, that
+									 * currently has an unconsumed result */
 } PgFdwConnState;
 
 /*
@@ -165,6 +170,7 @@ typedef enum PgFdwSamplingMethod
 extern int	set_transmission_modes(void);
 extern void reset_transmission_modes(int nestlevel);
 extern void process_pending_request(AsyncRequest *areq);
+extern void drain_other_active_scan(PgFdwConnState *conn_state);
 
 /* in connection.c */
 extern PGconn *GetConnection(UserMapping *user, bool will_prep_stmt,
@@ -174,8 +180,10 @@ extern unsigned int GetCursorNumber(PGconn *conn);
 extern unsigned int GetPrepStmtNumber(PGconn *conn);
 extern void do_sql_command(PGconn *conn, const char *sql);
 extern PGresult *pgfdw_get_result(PGconn *conn);
+extern PGresult *pgfdw_get_next_result(PGconn *conn);
 extern PGresult *pgfdw_exec_query(PGconn *conn, const char *query,
 								  PgFdwConnState *state);
+extern bool pgfdw_cancel_query(PGconn *conn, PgFdwConnState *state);
 pg_noreturn extern void pgfdw_report_error(PGresult *res, PGconn *conn,
 										   const char *sql);
 extern void pgfdw_report(int elevel, PGresult *res, PGconn *conn,
diff --git a/contrib/postgres_fdw/sql/postgres_fdw.sql b/contrib/postgres_fdw/sql/postgres_fdw.sql
index ec766e2b28a..313bd3f0deb 100644
--- a/contrib/postgres_fdw/sql/postgres_fdw.sql
+++ b/contrib/postgres_fdw/sql/postgres_fdw.sql
@@ -267,6 +267,153 @@ SELECT c3, c4 FROM ft1 ORDER BY c3, c1 LIMIT 1;  -- should work again
 ANALYZE ft1;
 ALTER FOREIGN TABLE ft2 OPTIONS (use_remote_estimate 'true');
 
+-- ===================================================================
+-- test streaming_fetch option
+-- ===================================================================
+CREATE SERVER fetch_stream_srv
+    FOREIGN DATA WRAPPER postgres_fdw
+    OPTIONS (dbname :'current_database', port :'current_port');
+CREATE USER MAPPING FOR CURRENT_USER SERVER fetch_stream_srv;
+
+CREATE TABLE local_tbl (id int, val text);
+INSERT INTO local_tbl VALUES (1, 'a'), (2, 'b'), (3, 'c');
+
+CREATE FOREIGN TABLE ft_server (id int, val text)
+    SERVER fetch_stream_srv
+    OPTIONS (schema_name 'public', table_name 'local_tbl');
+
+-- Combined view of the option at both levels, used by the checks below.
+CREATE VIEW streaming_fetch_opt AS
+SELECT (SELECT option_value FROM pg_foreign_server,
+               LATERAL pg_options_to_table(srvoptions)
+        WHERE srvname = 'fetch_stream_srv'
+          AND option_name = 'streaming_fetch') AS server_val,
+       (SELECT ftoptions FROM pg_foreign_table
+        WHERE ftrelid = 'ft_server'::regclass) AS table_opts;
+
+-- 1. streaming_fetch set at SERVER level only: value tracks the server,
+-- and (being unset) never shows up in the table's own ftoptions.
+ALTER SERVER fetch_stream_srv OPTIONS (ADD streaming_fetch 'true');
+SELECT * FROM streaming_fetch_opt;
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch 'false');
+SELECT * FROM streaming_fetch_opt;
+
+-- 2. streaming_fetch set at TABLE level only (no server-level option);
+-- query results must be correct for both true and false.
+ALTER SERVER fetch_stream_srv OPTIONS (DROP streaming_fetch);
+ALTER FOREIGN TABLE ft_server OPTIONS (ADD streaming_fetch 'true');
+SELECT * FROM streaming_fetch_opt;
+SELECT * FROM ft_server ORDER BY id;
+ALTER FOREIGN TABLE ft_server OPTIONS (SET streaming_fetch 'false');
+SELECT * FROM streaming_fetch_opt;
+SELECT * FROM ft_server ORDER BY id;
+
+-- 3. TABLE-level value overrides SERVER-level value; query must use the
+-- effective (table-level) value in both directions.
+ALTER SERVER fetch_stream_srv OPTIONS (ADD streaming_fetch 'true');
+ALTER FOREIGN TABLE ft_server OPTIONS (SET streaming_fetch 'false');
+SELECT * FROM streaming_fetch_opt;  -- server=true, table overrides to false
+SELECT * FROM ft_server ORDER BY id;
+
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch 'false');
+ALTER FOREIGN TABLE ft_server OPTIONS (SET streaming_fetch 'true');
+SELECT * FROM streaming_fetch_opt;  -- server=false, table overrides to true
+SELECT * FROM ft_server ORDER BY id;
+
+DROP VIEW streaming_fetch_opt;
+
+-- 4. Negative tests: invalid values must be rejected, at both table and
+-- server level.
+\set VERBOSITY terse
+
+CREATE FOREIGN TABLE ft_invalid (id int, val text)
+    SERVER fetch_stream_srv
+    OPTIONS (schema_name 'public', table_name 'local_tbl', streaming_fetch 'yes');  -- ERROR
+
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch '1');       -- ERROR
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch '');        -- ERROR
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch 'notabool'); -- ERROR
+
+\set VERBOSITY default
+
+-- 5. ALTER FOREIGN TABLE: add, change, and drop streaming_fetch
+ALTER SERVER fetch_stream_srv OPTIONS (SET streaming_fetch 'true');
+
+CREATE FOREIGN TABLE ft_alter_test (id int, val text)
+    SERVER fetch_stream_srv
+    OPTIONS (schema_name 'public', table_name 'local_tbl');
+
+-- No table-level option yet
+SELECT ftoptions FROM pg_foreign_table WHERE ftrelid = 'ft_alter_test'::regclass;
+
+ALTER FOREIGN TABLE ft_alter_test OPTIONS (ADD streaming_fetch 'false');
+SELECT ftoptions FROM pg_foreign_table WHERE ftrelid = 'ft_alter_test'::regclass;
+
+ALTER FOREIGN TABLE ft_alter_test OPTIONS (SET streaming_fetch 'true');
+SELECT ftoptions FROM pg_foreign_table WHERE ftrelid = 'ft_alter_test'::regclass;
+
+-- DROP table-level option (falls back to server-level), and confirm the
+-- fallback value is functionally correct.
+ALTER FOREIGN TABLE ft_alter_test OPTIONS (DROP streaming_fetch);
+SELECT ftoptions FROM pg_foreign_table WHERE ftrelid = 'ft_alter_test'::regclass;
+SELECT * FROM ft_alter_test ORDER BY id;
+
+DROP FOREIGN TABLE ft_alter_test;
+
+-- 6. streaming_fetch with non-default fetch_size values
+-- Use a 12-row table so chunk boundaries are distinct and predictable:
+-- fetch_size=1 gives 12 single-row chunks, fetch_size=5 gives chunks
+-- of 5+5+2, and fetch_size=1000 puts all rows in a single chunk.
+CREATE TABLE local_tbl_large (id int, val text);
+INSERT INTO local_tbl_large SELECT id, 'val' || id FROM generate_series(1, 12) id;
+
+-- fetch_size = 1: every row is its own libpq chunk; exercises the path
+-- where pgfdw_get_next_result is called once per row.
+CREATE FOREIGN TABLE ft_fetchsize (id int, val text)
+    SERVER fetch_stream_srv
+    OPTIONS (schema_name 'public', table_name 'local_tbl_large', fetch_size '1');
+SELECT count(*) FROM ft_fetchsize;
+
+-- fetch_size = 5: three chunks with a partial last chunk (5+5+2);
+-- the final chunk is smaller than fetch_size.
+ALTER FOREIGN TABLE ft_fetchsize OPTIONS (SET fetch_size '5');
+SELECT count(*) FROM ft_fetchsize;
+SELECT * FROM ft_fetchsize ORDER BY id;
+
+-- fetch_size exceeds the table row count: all rows arrive in one chunk
+-- followed immediately by the final empty PGRES_TUPLES_OK result.
+ALTER FOREIGN TABLE ft_fetchsize OPTIONS (SET fetch_size '1000');
+SELECT count(*) FROM ft_fetchsize;
+
+DROP FOREIGN TABLE ft_fetchsize;
+DROP TABLE local_tbl_large;
+
+-- 7. streaming_fetch combined with use_remote_estimate
+-- use_remote_estimate issues a remote EXPLAIN to size the scan at plan
+-- time; streaming_fetch must not interfere with that EXPLAIN call.
+-- ft_server's table-level option is still 'true' from step 3 above.
+ALTER SERVER fetch_stream_srv OPTIONS (ADD use_remote_estimate 'true');
+
+-- Verify both options are active.
+SELECT srvname, option_name, option_value
+FROM pg_foreign_server,
+     LATERAL pg_options_to_table(srvoptions)
+WHERE srvname = 'fetch_stream_srv'
+  AND option_name IN ('streaming_fetch', 'use_remote_estimate')
+ORDER BY option_name;
+
+-- Both options active: use_remote_estimate sizes the scan remotely via
+-- EXPLAIN, then streaming_fetch fetches rows without a cursor.
+EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft_server ORDER BY id;
+SELECT * FROM ft_server ORDER BY id;
+
+ALTER SERVER fetch_stream_srv OPTIONS (DROP use_remote_estimate);
+
+-- Cleanup
+DROP FOREIGN TABLE ft_server;
+DROP USER MAPPING FOR CURRENT_USER SERVER fetch_stream_srv;
+DROP SERVER fetch_stream_srv CASCADE;
+DROP TABLE local_tbl;
 -- ===================================================================
 -- test subscription
 -- ===================================================================
@@ -307,6 +454,33 @@ SELECT COUNT(*) FROM ft1 t1;
 SELECT * FROM ft1 t1 WHERE t1.c3 IN (SELECT c3 FROM ft2 t2 WHERE c1 <= 10) ORDER BY c1;
 -- subquery+MAX
 SELECT * FROM ft1 t1 WHERE t1.c3 = (SELECT MAX(c3) FROM ft2 t2) ORDER BY c1;
+-- Test in streaming_fetch mode to cover path from subquery params
+-- with only one table using streaming_fetch
+ALTER FOREIGN TABLE ft1 OPTIONS (streaming_fetch 'true');
+SELECT * FROM ft1 t1 WHERE t1.c3 = (SELECT MAX(c3) FROM ft2 t2) ORDER BY c1;
+-- Test join with only one table using streaming_fetch at a time
+SELECT t1.c1, t2."C 1" FROM ft2 t1 JOIN "S 1"."T 1" t2 ON (t1.c1 = t2."C 1") OFFSET 100 LIMIT 10;
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+ALTER FOREIGN TABLE ft2 OPTIONS (streaming_fetch 'true');
+SELECT t1.c1, t2."C 1" FROM ft2 t1 JOIN "S 1"."T 1" t2 ON (t1.c1 = t2."C 1") OFFSET 100 LIMIT 10;
+-- with both the tables using streaming_fetch
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+SELECT * FROM ft1 t1 WHERE t1.c3 = (SELECT MAX(c3) FROM ft2 t2) ORDER BY c1;
+-- Test join with both the tables using streaming_fetch
+SELECT t1.c1, t2."C 1" FROM ft2 t1 JOIN "S 1"."T 1" t2 ON (t1.c1 = t2."C 1") OFFSET 100 LIMIT 10;
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+-- streaming_fetch: verify correct results when parallel-friendly settings
+-- are active locally.  With no cursor on the remote side, the remote
+-- planner is free to choose a parallel plan; results must match exactly.
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+SET max_parallel_workers_per_gather = 2;
+SET min_parallel_table_scan_size = 0;
+SELECT count(*) FROM ft1;
+RESET max_parallel_workers_per_gather;
+RESET min_parallel_table_scan_size;
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+
 -- used in CTE
 WITH t1 AS (SELECT * FROM ft1 WHERE c1 <= 10) SELECT t2.c1, t2.c2, t2.c3, t2.c4 FROM t1, ft2 t2 WHERE t1.c1 = t2.c1 ORDER BY t1.c1;
 -- fixed values
@@ -386,6 +560,208 @@ EXPLAIN (VERBOSE, COSTS OFF)
   WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
 SELECT * FROM ft2 a, ft2 b
 WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+
+-- Test in streaming_fetch mode for rescan path
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+SELECT * FROM ft2 a, ft2 b
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+-- Test for streaming_fetch covering rescans and three active cursors
+SELECT count(*) FROM ft2 a, ft2 b, ft2 c
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND c.c1 = b.c1 AND a.c8 = 'foo'
+AND b.c7 = upper(a.c7);
+
+-- Test in streaming_fetch mode when a scan that is still the
+-- connection's active_scan (i.e. it has not reached EOF) correctly clears
+-- active_scan.
+ALTER FOREIGN TABLE ft2 OPTIONS (ADD fetch_size '1');
+SET enable_hashagg = off;
+SET enable_hashjoin = off;
+SET enable_mergejoin = off;
+SET enable_material = off;
+SET statement_timeout = '20s';
+
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT a.c1, a.c2 FROM ft1 a
+WHERE a.c1 < 20 AND a.c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = a.c2)
+ORDER BY a.c1;
+
+SELECT a.c1, a.c2 FROM ft1 a
+WHERE a.c1 < 20 AND a.c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = a.c2)
+ORDER BY a.c1;
+
+RESET statement_timeout;
+RESET enable_hashagg;
+RESET enable_hashjoin;
+RESET enable_mergejoin;
+RESET enable_material;
+ALTER FOREIGN TABLE ft2 OPTIONS (SET fetch_size '100');
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+
+-- Verify that aborting a transaction while a streaming_fetch scan still has
+-- an unconsumed chunked result correctly resets active_scan, so the
+-- connection can be reused afterward.
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+ALTER FOREIGN TABLE ft1 OPTIONS (ADD fetch_size '1');
+
+BEGIN;
+-- Fetch only the first row, leaving the stream unconsumed.
+SELECT c1 FROM ft1 ORDER BY c1 LIMIT 1;
+SELECT 1/0;  -- force an error, aborting with the scan still active
+ROLLBACK;
+
+SELECT count(*) FROM ft1;  -- must succeed
+
+ALTER FOREIGN TABLE ft1 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+
+-- Test that fetch_more_data()'s plain cursor-mode FETCH on ft1's own
+-- already-open cursor correctly accounts for another scan's active_scan.
+-- ft1's fetch_size is set below its matching row count, so its cursor
+-- needs a second FETCH; each outer row's EXISTS subplan on ft2 leaves the
+-- inner streaming_fetch scan as the connection's active_scan without
+-- reaching EOF (fetch_size '1' on ft2, and EXISTS only needs one match),
+-- so that second FETCH must drain it first (pgfdw_exec_query() does this
+-- automatically) or ft2's unconsumed chunked result would desync the
+-- connection's result stream.
+ALTER FOREIGN TABLE ft1 OPTIONS (ADD fetch_size '5');
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+ALTER FOREIGN TABLE ft2 OPTIONS (ADD fetch_size '1');
+SET enable_hashagg = off;
+SET enable_hashjoin = off;
+SET enable_mergejoin = off;
+SET enable_material = off;
+
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT a.c1, a.c2 FROM ft1 a
+WHERE a.c1 < 20 AND a.c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = a.c2)
+ORDER BY a.c1;
+
+SELECT a.c1, a.c2 FROM ft1 a
+WHERE a.c1 < 20 AND a.c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = a.c2)
+ORDER BY a.c1;
+
+RESET enable_hashagg;
+RESET enable_hashjoin;
+RESET enable_mergejoin;
+RESET enable_material;
+ALTER FOREIGN TABLE ft1 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft2 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+
+-- Test that fetch_from_tuplestore() correctly drains a large backlog in
+-- fetch_size-sized batches rather than all at once: with a small
+-- fetch_size and a self-join matching many rows per outer row, the outer
+-- scan's tuplestore (populated when the inner scan interrupts it to reuse
+-- the connection) needs several batched reads to fully drain.  If a batch
+-- were dropped or duplicated, the count below would not match.
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+ALTER FOREIGN TABLE ft2 OPTIONS (ADD fetch_size '5');
+SELECT count(*) FROM ft2 a, ft2 b
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+ALTER FOREIGN TABLE ft2 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+
+-- Test that execute_foreign_modify() correctly drains another scan's
+-- undrained streaming_fetch result before sending its own prepared
+-- statement.  The EXISTS subplan against ft2 (streaming_fetch, fetch_size
+-- 1) leaves ft2 as the connection's active_scan without reaching EOF after
+-- each outer row (short-circuiting on the first match), so each matching
+-- row's UPDATE on ft1 -- sent as a separate prepared statement per row,
+-- since the EXISTS subplan prevents direct modify -- must drain it first.
+-- The returned c1 values must match the known-correct row set for this
+-- same EXISTS predicate (see the plain SELECT variant of this query above).
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+ALTER FOREIGN TABLE ft2 OPTIONS (ADD fetch_size '1');
+SET enable_hashagg = off;
+SET enable_hashjoin = off;
+SET enable_mergejoin = off;
+SET enable_material = off;
+
+EXPLAIN (VERBOSE, COSTS OFF)
+UPDATE ft1 SET c3 = c3
+WHERE c1 < 20 AND c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = ft1.c2);
+
+BEGIN;
+UPDATE ft1 SET c3 = c3
+WHERE c1 < 20 AND c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = ft1.c2)
+RETURNING c1;
+ROLLBACK;
+
+RESET enable_hashagg;
+RESET enable_hashjoin;
+RESET enable_mergejoin;
+RESET enable_material;
+ALTER FOREIGN TABLE ft2 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+
+-- Test that execute_dml_stmt() (a fully pushed-down direct-modify
+-- UPDATE/DELETE) also drains another scan's undrained streaming_fetch
+-- result before sending its own query down the shared connection.  ft4
+-- shares the loopback connection with ft2; direct_modify_ft4() performs a
+-- self-contained, direct-modify-eligible UPDATE on ft4, called once per
+-- matching ft1 row while ft2's streaming EXISTS subplan is mid-stream.
+CREATE FUNCTION direct_modify_ft4(id int) RETURNS void AS $$
+  UPDATE ft4 SET c3 = c3 WHERE c1 = id;
+$$ LANGUAGE sql;
+
+EXPLAIN (VERBOSE, COSTS OFF) UPDATE ft4 SET c3 = c3 WHERE c1 = 1;
+
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+ALTER FOREIGN TABLE ft2 OPTIONS (ADD fetch_size '1');
+SET enable_hashagg = off;
+SET enable_hashjoin = off;
+SET enable_mergejoin = off;
+SET enable_material = off;
+
+BEGIN;
+SELECT direct_modify_ft4(a.c1) FROM ft1 a
+WHERE a.c1 < 20 AND a.c8 = 'foo' AND EXISTS (SELECT 1 FROM ft2 b WHERE b.c2 = a.c2)
+ORDER BY a.c1;
+ROLLBACK;
+
+RESET enable_hashagg;
+RESET enable_hashjoin;
+RESET enable_mergejoin;
+RESET enable_material;
+ALTER FOREIGN TABLE ft2 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+DROP FUNCTION direct_modify_ft4(int);
+
+-- Test in streaming_fetch mode for interleaved scans.
+-- The non-shippable condition a.c8 = 'foo' prevents full
+-- join pushdown, so the planner issues two separate FDW scans.
+-- When the inner scan is initiated it first drains the outer scan's unread rows.
+ ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+
+-- Show the plan: ft2 must appear as two independent ForeignScan nodes, not
+-- a single pushed-down remote join.
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT * FROM ft2 a, ft2 b
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+
+-- Verify results with cursor path.
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+SELECT * FROM ft2 a, ft2 b
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+
+-- Three-way self-join to test streaming_fetch
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT count(*) FROM ft2 a, ft2 b, ft2 c
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND c.c1 = b.c1
+AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+
+SELECT count(*) FROM ft2 a, ft2 b, ft2 c
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND c.c1 = b.c1
+AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+
+-- output matches in cursor mode
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
+SELECT count(*) FROM ft2 a, ft2 b, ft2 c
+WHERE a.c2 = 6 AND b.c1 = a.c1 AND c.c1 = b.c1
+AND a.c8 = 'foo' AND b.c7 = upper(a.c7);
+
+
 -- bug before 9.3.5 due to sloppy handling of remote-estimate parameters
 SELECT * FROM ft1 WHERE c1 = ANY (ARRAY(SELECT c1 FROM ft2 WHERE c1 < 5));
 SELECT * FROM ft2 WHERE c1 = ANY (ARRAY(SELECT c1 FROM ft1 WHERE c1 < 5));
@@ -711,6 +1087,16 @@ SELECT t1.c1 FROM ft1 t1 WHERE EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c1)
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
 SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+
+-- Test in streaming_fetch mode to cover the patch for two simultaneous active cursors
+-- with only one table using streaming_fetch
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+-- with both the tables using streaming_fetch
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'true');
+SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+ALTER FOREIGN TABLE ft2 OPTIONS (SET streaming_fetch 'false');
 -- CROSS JOIN can be pushed down
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT t1.c1, t2.c1 FROM ft1 t1 CROSS JOIN ft2 t2 ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
@@ -719,6 +1105,12 @@ SELECT t1.c1, t2.c1 FROM ft1 t1 CROSS JOIN ft2 t2 ORDER BY t1.c1, t2.c1 OFFSET 1
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN ft6 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
 SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN ft6 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+-- Test in streaming_fetch mode to cover the case with multiple cursors but only one active cursor at a time
+ALTER FOREIGN TABLE ft5 OPTIONS (streaming_fetch 'true');
+ALTER FOREIGN TABLE ft6 OPTIONS (streaming_fetch 'true');
+SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN ft6 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ALTER FOREIGN TABLE ft5 OPTIONS (SET streaming_fetch 'false');
+ALTER FOREIGN TABLE ft6 OPTIONS (SET streaming_fetch 'false');
 -- unsafe join conditions (c8 has a UDT), not pushed down. Practically a CROSS
 -- JOIN since c8 in both tables has same value.
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -1140,6 +1532,31 @@ explain (verbose, costs off)
 select count(c6), sum(c1), avg(c1), min(c2), max(c1), stddev(c2), sum(c1) * (random() <= 1)::int as sum2 from ft1 where c2 < 5 group by c2 order by 1, 2 limit 1;
 select count(c6), sum(c1), avg(c1), min(c2), max(c1), stddev(c2), sum(c1) * (random() <= 1)::int as sum2 from ft1 where c2 < 5 group by c2 order by 1, 2 limit 1;
 
+-- Test with limit and streaming_fetch
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+select count(c6), sum(c1), avg(c1), min(c2), max(c1), stddev(c2), sum(c1) * (random() <= 1)::int as sum2 from ft1 where c2 < 5 group by c2 order by 1, 2 limit 1;
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+
+-- Test LIMIT stopping before all tuples are consumed.
+-- The WHERE clause references c8 (a user-defined type that cannot be
+-- pushed to the remote), preventing LIMIT pushdown.  The remote
+-- therefore streams all rows, and end_scan must discard the in-flight
+-- data when the local executor stops early.
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+-- LIMIT 5 with default fetch_size=100: stops well within the first
+-- chunk; end_scan discards ~995 rows still in flight on the connection.
+SELECT c1 FROM ft1 WHERE c8 = 'foo' ORDER BY c1 LIMIT 5;
+-- Verify the connection is still usable after the early stop.
+SELECT count(*) FROM ft1;
+-- fetch_size=10, LIMIT=15: consumes one full chunk (rows 1-10) plus 5
+-- rows from a second chunk (rows 11-15); end_scan then discards the
+-- remainder of that chunk and all subsequent in-flight chunks.
+ALTER FOREIGN TABLE ft1 OPTIONS (fetch_size '10');
+SELECT c1 FROM ft1 WHERE c8 = 'foo' ORDER BY c1 LIMIT 15;
+SELECT count(*) FROM ft1;
+ALTER FOREIGN TABLE ft1 OPTIONS (DROP fetch_size);
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+
 -- Aggregate is not pushed down as aggregation contains random()
 explain (verbose, costs off)
 select sum(c1 * (random() <= 1)::int) as sum, avg(c1) from ft1;
@@ -3909,6 +4326,41 @@ SELECT 1 FROM ft1 LIMIT 1;    -- should fail
 \set VERBOSITY default
 COMMIT;
 
+-- ===================================================================
+-- streaming_fetch: error recovery when the remote backend terminates
+-- ===================================================================
+-- Enable streaming_fetch
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+
+-- Establish a fresh remote connection.
+SELECT 1 FROM ft1 LIMIT 1;
+
+-- Terminate the remote backend and wait for the termination to complete.
+DO $$ BEGIN
+PERFORM pg_terminate_backend(pid, 180000) FROM pg_stat_activity
+	WHERE application_name = 'fdw_retry_check';
+END $$;
+
+-- After the connection is broken, a streaming_fetch query should detect
+-- the broken connection, reestablish it, and succeed.
+BEGIN;
+SELECT c1 FROM ft1 ORDER BY c1 LIMIT 3;
+
+-- Inside a subtransaction the broken connection must not be silently
+-- retried; the query should fail.
+DO $$ BEGIN
+PERFORM pg_terminate_backend(pid, 180000) FROM pg_stat_activity
+	WHERE application_name = 'fdw_retry_check';
+END $$;
+SAVEPOINT s2;
+-- The text of the error might vary across platforms, so only show SQLSTATE.
+\set VERBOSITY sqlstate
+SELECT 1 FROM ft1 LIMIT 1;    -- should fail
+\set VERBOSITY default
+COMMIT;
+
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
+
 -- =============================================================================
 -- test connection invalidation cases and postgres_fdw_get_connections function
 -- =============================================================================
@@ -4477,6 +4929,29 @@ SELECT * FROM local_tbl, async_pt WHERE local_tbl.a = async_pt.a AND local_tbl.c
 ALTER FOREIGN TABLE async_p1 OPTIONS (DROP use_remote_estimate);
 ALTER FOREIGN TABLE async_p2 OPTIONS (DROP use_remote_estimate);
 
+-- Test with streaming_fetch
+-- No streaming_fetch at server, this should give Async Foreign Scan for for async_p1 and async_p2
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT * FROM async_pt;
+
+-- streaming_fetch = false at loopback server, this should still give Async Foreign Scan for async_p1 and async_p2
+ALTER SERVER loopback OPTIONS (streaming_fetch 'false');
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT * FROM async_pt;
+
+-- streaming_fetch = false at loopback server but true for async_p1, this should give Foreign Scan for async_p1
+ALTER FOREIGN TABLE async_p1 OPTIONS (ADD streaming_fetch 'true');
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT * FROM async_pt;
+
+-- streaming_fetch = true at loopback2 server, this should give Foreign Scan for async_p2 also
+ALTER SERVER loopback2 OPTIONS (streaming_fetch 'true');
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT * FROM async_pt;
+
+ALTER FOREIGN TABLE async_p1 OPTIONS (DROP streaming_fetch);
+ALTER SERVER loopback OPTIONS (DROP streaming_fetch);
+ALTER SERVER loopback2 OPTIONS (DROP streaming_fetch);
 DROP TABLE local_tbl;
 DROP INDEX base_tbl1_idx;
 DROP INDEX base_tbl2_idx;
diff --git a/contrib/postgres_fdw/sql/query_cancel.sql b/contrib/postgres_fdw/sql/query_cancel.sql
index a6830705843..d4d15ccaf8f 100644
--- a/contrib/postgres_fdw/sql/query_cancel.sql
+++ b/contrib/postgres_fdw/sql/query_cancel.sql
@@ -20,3 +20,19 @@ SET LOCAL statement_timeout = '10ms';
 -- This would take very long if not canceled:
 SELECT count(*) FROM ft1 a CROSS JOIN ft1 b CROSS JOIN ft1 c CROSS JOIN ft1 d;
 COMMIT;
+
+-- Same as above, but for a streaming_fetch (cursor-free) scan: verify that
+-- canceling mid-stream correctly clears conn_state->active_scan, so the
+-- connection is safely reusable afterward.
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'true');
+
+BEGIN;
+SELECT count(*) FROM ft1 a;
+SET LOCAL statement_timeout = '10ms';
+SELECT count(*) FROM ft1 a CROSS JOIN ft1 b CROSS JOIN ft1 c CROSS JOIN ft1 d;
+COMMIT;
+
+-- Must succeed cleanly if active_scan was properly cleared on cancel.
+SELECT count(*) FROM ft1;
+
+ALTER FOREIGN TABLE ft1 OPTIONS (SET streaming_fetch 'false');
diff --git a/doc/src/sgml/postgres-fdw.sgml b/doc/src/sgml/postgres-fdw.sgml
index 87b1433aacb..e4ed483b0a3 100644
--- a/doc/src/sgml/postgres-fdw.sgml
+++ b/doc/src/sgml/postgres-fdw.sgml
@@ -476,6 +476,23 @@ OPTIONS (ADD password_required 'false');
      </listitem>
     </varlistentry>
 
+    <varlistentry>
+     <term><literal>streaming_fetch</literal> (<type>boolean</type>)</term>
+     <listitem>
+      <para>
+       Specifies whether to fetch rows from the remote server without
+       using a cursor. When enabled, the remote server is free to use
+       parallel query plans, which can significantly improve performance
+       for large scans. When a second scan begins on the same connection
+       while one is already in progress, the remaining rows of the first scan
+       are buffered locally (using work_mem) and replayed on demand.
+       Asynchronous execution is not supported in this mode and is disabled
+       automatically. The default is <literal>false</literal>. It can be
+       specified for a foreign table or a foreign server. The option
+       specified on a table overrides an option specified for the server.
+      </para>
+     </listitem>
+    </varlistentry>
    </variablelist>
 
   </sect3>
-- 
2.39.5 (Apple Git-154)

